unit Main;
{*********************************************************}
{*            NCOCI8 Asta server v 0.1.0                 *}
{*********************************************************}
{*     Copyright (c) 1997-99 Asta Technology Group LLC   *}
{*              Partional rights reserved.               *}
{*                 www.astatech.com                      *}
{*********************************************************}
{*           Copyright (c) 2000 Dmitry Arefiev           *}
{*             Partional rights reserved.                *}
{*            www.ncom.ru/diman/index.html               *}
{*********************************************************}
{$D+,L+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, AstaServer, StdCtrls, Db, Grids, DBGrids, ComCtrls, AstaDrv2,
  Buttons, ExtCtrls, DBCtrls, AstaDBTools, checklst, astaparamlist,
  AstaCustomSocket, AstaClientSocket, astastringline, AstaSQLGenerate;

type
  TfrmMain = class(TForm)
    AstaServerSocket1: TAstaServerSocket;
    PageControl: TPageControl;
    MemoTabsheet: TTabSheet;
    mRequests: TMemo;
    ConnectedTabSheet: TTabSheet;
    UserDataSet: TAstaDataset;
    DataSource1: TDataSource;
    UserGrid: TDBGrid;
    TabSheet1: TTabSheet;
		GroupBox3: TGroupBox;
    ReceiveMemo: TMemo;
		BitBtn1: TBitBtn;
    TabSheet3: TTabSheet;
    ErrorMemo: TMemo;
    DBMSDataSet: TAstaDataSet;
		GroupBox1: TGroupBox;
    SendMemo: TMemo;
    TabSheet4: TTabSheet;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    TabSheet5: TTabSheet;
    CheckListBox1: TCheckListBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    TabSheet6: TTabSheet;
    Memo2: TMemo;
    ServerDataSets: TAstaDataSet;
    AstaStoredProcColumnDataSet: TAstaDataSet;
    mLogin: TMemo;
    mSelectSend: TMemo;
    mBroadcastMessage: TMemo;
    mBroadcastPopupMessage: TMemo;
    UserDataSetAddress: TStringField;
    UserDataSetActivity: TStringField;
		UserDataSetDate: TDateTimeField;
    IndexDataSet: TAstaDataSet;
    TableDataSet: TAstaDataSet;
    ColumnDataSet: TAstaDataSet;
    AstaSPNamedataSet: TAstaDataSet;
    AstaSQLGenerator1: TAstaSQLGenerator;
		procedure FormCreate(Sender: TObject);
    procedure AstaServerSocket1ClientConnect(Sender: TObject;
			Socket: TCustomWinSocket);
    procedure AstaServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button5Click(Sender: TObject);
    procedure AstaServerSocket1ClientLogin(Sender: TObject; UserName,
      Password, AppName: string; var Verified: Boolean);
    procedure AstaServerSocket1ExecSQLParamList(Sender: TObject;
      ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
      SQLString: String; var TheResult: Boolean; var Msg: String;
      ParamList: TAstaParamList);
    procedure AstaServerSocket1FetchBlobEvent(Sender: TObject;
      ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
      TableName, FieldName, WhereString: String; var M: TMemoryStream);
    procedure AstaServerSocket1FetchMetaData(Sender: TObject;
      ClientSocket: TCustomWinSocket; MetaRequest: TAstaMetaData;
      DataBaseStr, Arg1, Arg2: String);
    procedure AstaServerSocket1SubmitSQL(Sender: TObject;
      ClientSocket: TCustomWinSocket; AQuery: TDataSet; DataBaseStr,
      SQLString: String; Options: TAstaSelectSQLOptionSet);
    procedure AstaServerSocket1ShowServerMessage(Sender: TObject;
      Msg: String);
    procedure AstaServerSocket1TransactionBegin(Sender: TObject;
      ClientSocket: TCustomWinSocket; Session: TComponent;
      TransActionName: String);
    procedure AstaServerSocket1TransactionEnd(Sender: TObject;
      ClientSocket: TCustomWinSocket; Session: TComponent;
      Success: Boolean);
    procedure AstaServerSocket1ThreadedDBSupplySession(Sender: TObject;
      ClientSocket: TCustomWinSocket; DataBaseString: String;
      var ASession: TComponent);
    procedure AstaServerSocket1ClientDBLogin(Sender: TObject; TheUserName,
      ThePassword, TheAppName: String; var Verified: Boolean;
      var ADataBase: TComponent);
    procedure AstaServerSocket1ThreadedDBSupplyQuery(Sender: TObject;
      ClientSocket: TCustomWinSocket; DBAction: TThreadDbAction;
      DataBaseStr: String; CreateNew: Boolean; var AQuery: TComponent;
      SQLOptions: TAstaSelectSQLOptionSet);
    procedure AstaServerSocket1CodedMessage(Sender: TObject;
      ClientSocket: TCustomWinSocket; MsgID: Integer; Msg: String);
    procedure AstaServerSocket1InsertAutoIncrementFetch(Sender: TObject;
      ClientSocket: TCustomWinSocket; AQuery: TComponent; TheDatabase,
      TheTable, TheAutoIncField: String; var AutoIncrementValue: Integer);
    procedure AstaServerSocket1Decrypt(Sender: TObject; var S: string);
    procedure AstaServerSocket1Encrypt(Sender: TObject; var S: string);
    procedure AstaServerSocket1ChatLine(Sender: TObject; S: String);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure AstaServerSocket1StoredProcedure(Sender: TObject;
      ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
      AStoredProcName: String; ClientParams: TAstaParamList;
      NoResultSet: Boolean);
	private
		{ Private declarations }
	public
		{ Public declarations }
		FExceptionMessage: string;
		Counter: LongInt;
		FUserName, FPassword: string;
    FLogOn: Boolean;
		procedure PopulateTableNames;
		procedure PopulateFieldNames(TableName:String);
		procedure PopulateViewNames;
		procedure PopulateStoredProcNames;
		procedure LogException(Sender:TObject;ErrorMsg: string; SendToClient: Boolean);
		procedure SetupDBMSDataBase;
		procedure AstaException(Sender: TObject; E: Exception);
    procedure PopulateStoredProcColumns(SPName:String);
    Procedure SetUpThreads;
    Procedure ReLogonToAllSessions;
		procedure UpdateUserDataSet(Address: string; Connected: Boolean);
    procedure Logit(S: string);
    procedure PopulateIndexNames(TableName: String);
	end;

var
	frmMain: TfrmMain;

implementation
{$R *.DFM}

uses astaabout, AstaUtil, AstaClientDataset, astathread, astadatamodule, NCOci,
     NCOciWrapper, NCOciDB, NCOciParams;

const
	AstaDataBase = 'AstaDataBase';

procedure TfrmMain.AstaException(Sender: TObject; E: Exception);
var
  Sendit: Boolean;
begin
  AstaServersocket1.VerifyClientconnections;
  Sendit := True;
  if E is ESocketError then begin
    FExceptionMessage := ESocketError(ExceptObject).Message;
    errormemo.lines.add(FExceptionMessage);
    exit;
  end
  else if E is EDataBaseError then
    FExceptionMessage := EDataBaseError(E).Message
  else
    FExceptionMessage := E.Message;
  if (Sender <> nil) then begin
    if not (Sender is TCustomWinSocket) then
      LogException(nil, FExceptionMessage, Sendit)
    else
      LogException(Sender, FExceptionMessage, Sendit);
  end;
end;

procedure TfrmMain.LogException(Sender:TObject;ErrorMsg: string; SendToClient: Boolean);
begin
  if SendToClient then
    AstaServerSocket1.SendExceptionToClient(Sender as TCustomWinSocket, ErrorMsg);
  LogIt(ErrorMsg);
end;

procedure TfrmMain.Logit(S: string);
begin
  if FLogOn then
    mRequests.Lines.Add(s);
end;

procedure TfrmMain.SetupDBMSDataBase;
begin
  with DBMSDataSet do begin
    AppendRecord([AstaServerSocket1.AstaServerName,
      DM.MainSession.UserName + '@' + DM.MainSession.ServerName,
      '', ExtractFileName(Application.EXEName)]);
    UpdateAstaAlias(DBMSDataSet);
  end;
end;

Procedure TFrmMain.SetUpThreads;
begin
  with dm do
  try
    Caption := 'ASTA NCOCI8 Server www.astatech.com ' + AstaVersion +
      ' listening on port ' + IntToStr(AstaServerSocket1.Port);
    AstaServerSocket1.CreateSessionsForDbThreads(True);
    //changed the above to true to force ASTA to dispose of the DataModule in Pooled Sessions
    Case AstaServerSocket1.ThreadingModel of
      tmSingleSession:
        Caption := Caption + ' using connect string ' + MainSession.UserName +
          '@' + MainSession.ServerName;
      tmPooledSessions:
        Caption := Caption + ' ' + IntToStr(AstaServerSocket1.SessionList.Count) +
          ' Sessions using  ' + DM.MainSession.ServerName;
      tmPersistentSessions:
        Caption := Caption + ' Persistent Sessions using ' + DM.MainSession.ServerName;
    end;
  except
    LogException(nil,' Problems resetting thread model'+' '+EDataBaseError(ExceptObject).Message,True);
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  FLogOn := True;
  if ParamBool('NoLog') then FLogOn := False;
  FExceptionMessage := '';
  I := ParamCheck('User=');
  if i > 0 then begin
    DM.MainSession.Close;
    DM.MainSession.ConnectString := StringAfterToken(ParamStr(i), '=');
  end;
  if ParamBool('AstaEncryption') then
    AstaServerSocket1.Encryption := etAstaEncrypt;
  Application.OnException := AstaException;
  //this is important to get SQL work bench to Function!  Do not remove
  AstaServerSocket1.CommandLinePortcheck;
  AstaServerSocket1.Active := True;
  Caption := Caption + ' ' + AstaVersion + ' listening on port ' + IntToStr(AstaServerSocket1.Port);
  try
    dm := TAstaOracleDataModule.Create(Application);
    DM.MainSession.Open;
  except
    ShowMessage('Unable to Log on to ' + DM.MainSession.ServerName);
    Application.Terminate;
  end;
  AstaServerSocket1.DataBaseName := DM.MainSession.DatabaseName;
  SetupDBMSDataBase;
  AstaServerSocket1.RegisterDataModule(self);
  AstaServerSocket1.RegisterDataModule(dm);
  Counter := 0;
  SetupThreads;
end;

procedure TfrmMain.UpdateUserDataSet(Address: string; Connected: Boolean);
begin
  with UserDataSet do begin
    Open;
    Append;
    FieldbyName('Address').AsString := Address;
    if connected then FieldbyName('Activity').AsString := 'Connected'
    else FieldbyName('Activity').AsString := 'Disconnected';
    FieldByName('Date').AsDATeTime := Now;
    Post;
  end;
end;

procedure TfrmMain.AstaServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  UpdateUserDataSet(Socket.RemoteAddress, True);
end;

procedure TfrmMain.AstaServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  UpdateUserDataSet(Socket.RemoteAddress, False);
end;

procedure TfrmMain.Button5Click(Sender: TObject);
begin
  AstaServerSocket1.KillSelectedUsers('Your application is being terminated by ' +
    'the System Administrator.');
end;

procedure TfrmMain.AstaServerSocket1ChatLine(Sender: TObject; S: String);
begin
  ReceiveMemo.Lines.Add(S);
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  AstaServerSocket1.SendBroadCastPopUp(SendMemo.Text, False);
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  AstaServerSocket1.SendBroadcastPopUp(mBroadcastPopupMessage.Text, False);
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
  // Broadcasts can be coded with MsgIDs. Using case statements at the client
  // you can choose to treat different broadcasts differently
  AstaServerSocket1.SendBroadcastEvent(mBroadCastMessage.Text, False);
end;

procedure TfrmMain.Button6Click(Sender: TObject);
begin
  AstaServerSocket1.SendSelectPopupMessage(mSelectSend.Text);
end;

procedure TfrmMain.Button7Click(Sender: TObject);
begin
  AstaServerSocket1.SendSelectCodedMessage(500, mSelectSend.Text);
end;

procedure TfrmMain.AstaServerSocket1ClientLogin(Sender: TObject; UserName,
  Password, AppName: string; var Verified: Boolean);
begin
// This is where you would attempt to verify your users. "Verified" should hold
// the result of you attempt.  In this demo we will simply display the fields and
// assume the verification was True.

// Display the information
  mLogin.Lines.Add('UserName: ' + UserName + ' Password: ' + Password + ' Application Name: ' + AppName);
// Return a successful login attempt
  Verified := True;
end;

procedure TfrmMain.AstaServerSocket1Decrypt(Sender: TObject; var S: string);
begin
  S := SimpleDecrypt(S);
end;

procedure TfrmMain.AstaServerSocket1Encrypt(Sender: TObject; var S: string);
begin
  S := SimpleEncrypt(S);
end;

procedure TfrmMain.AstaServerSocket1FetchMetaData(Sender: TObject;
  ClientSocket: TCustomWinSocket; MetaRequest: TAstaMetaData; DataBaseStr,
  Arg1, Arg2: String);
var
  i: Integer;
begin
  if (MetaRequest in [mdCustomDataSets, mdFields, mdIndexes, mdPrimeKeys,
     mdForeignKeys, mdStoredProcColumns]) and (Arg1 = '') then
    Exit;
	try
		case MetaRequest of
			mdCustomDataSets:
        begin
				  //add other data module datasets here with full extension!
					for i := 0 to componentcount - 1 do
						if (comparetext(Components[i].Name, Arg1) = 0) and
							(Components[i] is TDataSet) then begin
							AstaServerSocket1.MetaDataSet := TDataSet(Components[i]);
              LogIt('Using Server Side DataSet:' + Arg1);
						end;
				end;
			mdFields:
        begin
          LogIt('Fields Info for ' + Arg1);
 				  PopulateFieldNames(Arg1);
				  AstaServerSocket1.MetaDataSet := dm.FieldDataSet;
				end;
			mdIndexes, mdPrimeKeys, mdForeignKeys:
        begin
          LogIt('Index Info for ' + Arg1);
 				  PopulateIndexNames(Arg1);
					AstaServerSocket1.MetaDataSet := IndexDataSet;
				end;
			mdStoredProcColumns:
        begin
					LogIt('Stored Proc Param Info for ' + Arg1);
          PopulateStoredProcColumns(arg1);
	        AstaServerSocket1.MetaDataSet := AstaStoredProcColumnDataSet;
				end;
			mdStoredProcs:
        begin
					LogIt('Stored Procedure List');
				  PopulateStoredProcNames;
	        AstaServerSocket1.MetaDataSet := AstaSpNameDataSet;
				end;
			mdDBMSName:
        begin
					LogIt('DBMS Info Request');
					AstaServerSocket1.MetaDataSet := DBMSDataSet;
				end;
			mdServerDataSets:
        begin
					LogIt('Server DataSet Info Request');
					AstaServerSocket1.MetaDataSet := ServerDataSets;
				end;
		  mdviews:
        begin
				  LogIt('View Info');
				  PopulateViewNames;
				  AstaServerSocket1.MetaDataSet := TableDataSet;
			  end;
		  else begin
				LogIt('Table Info');
				PopulateTableNames;
				AstaServerSocket1.MetaDataSet := TableDataSet;
			end;
		end;
	except
		LogException(ClientSocket,'MetaData Error: ' + EDataBaseError(ExceptObject).Message, True);
	end;
end;

procedure TfrmMain.AstaServerSocket1FetchBlobEvent(Sender: TObject;
  ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
  TableName, FieldName, WhereString: String; var M: TMemoryStream);
begin
  with TOCIQuery(AQuery) do
  try
    if Active then
      Close;
    SQL.Clear;
    SQL.Add('Select ' + FieldName + ' FROM ' + TableName + #13 + WhereString);
	  LogIt('Blob Fetch :' + SQL.Text);
	  Open;
	  if not Eof then
      case FieldByName(FieldName).DataType of
        ftmemo,ftOraClob: TMemoField(FieldByName(FieldName)).SaveToStream(M);
        ftblob,ftOraBlob: TBlobField(FieldbyName(FieldName)).SaveToStream(M);
     	end;
  except
		LogException(ClientSocket,'Blob Fetch Error: ' + EDataBaseError(ExceptObject).Message, True);
  end;
end;

procedure TfrmMain.PopulateTableNames;
begin
  with dm do begin
    TablesDataSet.Close;
    TablesDataSet.Open;
    TableDataSet.DisableControls;
    TableDataSet.Empty;
    with TablesDataSet do
      while not Eof do begin
        TableDataSet.AppendRecord([Fields[0].AsString + '.' +
                                   Fields[1].AsString]);
        next;
      end;
    TableDataSet.First;
    TableDataSet.EnableControls;
  end;
end;

procedure TfrmMain.PopulateIndexNames(TableName:String);
begin
end;

procedure TfrmMain.PopulateFieldNames(TableName:String);
begin
  with Dm do begin
    if pos('.', TableName) > 0 then
      TableName := StringAfterToken(TableName, '.');
	  FieldDataSet.Close;
	  FieldDataSet.ParamByName('TableName').AsString := TableName;
	  FieldDataSet.Open;
  end;
end;

procedure TfrmMain.PopulateStoredProcNames;
begin
  with Dm do begin
    SpNameDataSet.Close;
   	SpNameDataSet.Open;
    AstaSPNameDataSet.DisableControls;
    AstaSPNameDataSet.Empty;
    with SpNameDataSet do
      while not Eof do begin
        AstaSpNameDataSet.AppendRecord([FieldbyName('Owner').AsString + '.' +
                                        FieldbyName('Object_name').AsString]);
        Next;
      end;
    AstaSPNameDataSet.First;
    AstaSPNameDataSet.EnableControls;
  end;
end;

procedure TfrmMain.PopulateStoredProcColumns(SPName:String);
var
  i: Integer;
begin
  with Dm do begin
    SpColumnDataSet.StoredProcName := SPName;
    SpColumnDataSet.Prepare;
	  AstaStoredProcColumnDataSet.Open;
	  AstaStoredProcColumnDataSet.Empty;
    LogIt(IntToStr(SpColumnDataSet.Params.Count)+' params');
    for i := 0 to SpColumnDataSet.Params.Count - 1 do begin
			AstaStoredProcColumnDataSet.Append;
			AstaStoredProcColumnDataSet.FieldByName('Name').AsString:=
        SpColumnDataSet.Params[i].Name;
      AstaStoredProcColumnDataSet.FieldbyName('InputType').AsInteger:=
        Integer(SpColumnDataSet.Params[i].ParamType);
      AstaStoredProcColumnDataSet.FieldbyName('DataType').AsInteger:=
        Integer(SpColumnDataSet.Params[i].DataType);
			AstaStoredProcColumnDataSet.Post;
		end;
  end;
end;

procedure TfrmMain.PopulateViewNames;
begin
  with dm do begin
    ViewsDataSet.Close;
    ViewsDataSet.Open;
    TableDataSet.DisableControls;
	  TableDataSet.Empty;
    with ViewsDataSet do
      while not Eof do begin
	  	  TableDataSet.AppendRecord([FieldbyName('Owner').AsString + '.' +
                                   FieldbyName('Object_name').AsString]);
        Next;
      end;
	  TableDataSet.First;
    TableDataSet.EnableControls;
  end;
end;

procedure TfrmMain.AstaServerSocket1ExecSQLParamList(Sender: TObject;
  ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
  SQLString: String; var TheResult: Boolean; var Msg: String;
  ParamList: TAstaParamList);
var
  I: Integer;
begin
  with TOCIQuery(AQuery) do
  try
    TheResult := False;
    LogIt('Exec ParamList Call: ' + SQLString);
    for I := 0 to ParamList.Count - 1 do
      if not (ParamList[I].datatype in [ftblob, ftmemo]) then
        LogIt(' Param ' + IntToStr(I) + '->' + ParamList[i].Name + ' ' + ParamList[i].AsString)
      else
        LogIt(' Param ' + IntToStr(I) + '->' + ParamList[i].Name + ' Size ' + IntToStr(Length(ParamList[i].AsString)));
    Active := False;
    SQL.Clear;
    SQL.Add(SqlString);
    for I := 0 to ParamList.Count - 1 do begin
      if ParamList[i].IsNull then begin
        Params[i].DataType := ParamList[i].DataType;
        Params[i].Clear;
        Params[i].Bound := True;
      end else
        case ParamList[i].DataType of
          ftstring: Params[i].AsString := ParamList[i].AsString;
          ftinteger, ftsmallint, ftword: Params[i].AsInteger := ParamList[i].AsInteger;
          ftfloat: Params[i].AsFloat := ParamList[i].AsFloat;
          ftboolean: Params[i].AsBoolean := ParamList[i].AsBoolean;
          fttime, ftdate, ftdatetime: Params[i].AsDateTime := ParamList[i].AsDateTime;
          ftblob, ftgraphic: Params[i].AsBlob := ParamList[i].AsString;
          ftmemo: Params[i].AsMemo := ParamList[i].AsString;
        end;
    end;
    ExecSQL;
    TheResult := True;
  except
     Msg := Exception(exceptObject).Message;
     LogException(ClientSocket,'ExecSQL->' + Exception(exceptObject).Message, False);
  end;
end;

procedure TfrmMain.AstaServerSocket1SubmitSQL(Sender: TObject;
  ClientSocket: TCustomWinSocket; AQuery: TDataSet; DataBaseStr,
  SQLString: String; Options: TAstaSelectSQLOptionSet);
begin
  with TOCIQuery(AQuery) do
  try
    Disconnect;
    LogIt(SQLString);
    SQL.Clear;
    SQL.Add(SQLString);
    Open;
  except
		LogException(ClientSocket,'Submit SQL: ' + EDataBaseError(ExceptObject).Message, True);
  end;
end;

procedure TfrmMain.AstaServerSocket1ShowServerMessage(Sender: TObject;
  Msg: String);
begin
  LogIt(msg);
end;

procedure TfrmMain.AstaServerSocket1TransactionBegin(Sender: TObject;
  ClientSocket: TCustomWinSocket; Session: TComponent;
  TransActionName: String);
begin
  try
    LogIt('Start Transaction :' + TransactionName);
    (Session as TOCIDataBase).StartTransaction;
  except
    LogException(ClientSocket, 'Transaction Begin: ' + Exception(exceptObject).Message, True);
  end;
end;

procedure TfrmMain.AstaServerSocket1TransactionEnd(Sender: TObject;
  ClientSocket: TCustomWinSocket; Session: TComponent; Success: Boolean);
begin
  try
    if Success then begin
      LogIt('Transacion Commit');
      (Session as TOCIDatabase).Commit;
    end
    else begin
      LogIt('Transaction RollBack');
      (Session as TOCIDatabase).RollBack;
    end;
  except
		LogException(ClientSocket,'Transaction End: ' + EDataBaseError(ExceptObject).Message, True);
  end;
end;

procedure TfrmMain.AstaServerSocket1ThreadedDBSupplySession(
  Sender: TObject; ClientSocket: TCustomWinSocket; DataBaseString: String;
  var ASession: TComponent);
begin
  try
    ASession := TAstaOracleDataModule.Create(nil);
    with ASession as TAstaOracleDataModule do begin
      MainSession.ConnectString := DM.MainSession.ConnectString;
      MainSession.SilentMode := True;
      MainSession.Open;
    end;
  except
    LogException(ClientSocket,'Unable to Create Session: ' + EDataBaseError(ExceptObject).Message, True);
  end;
end;

Procedure TFrmMain.ReLogonToAllSessions;
var
  i: Integer;
  ADM: TastaOracleDataModule;
begin
  try
    DM.MainSession.Close;
    DM.MainSession.Open;
    LogIt('Main Database reconnected');
  except
    LogIt('Problems reconnecting to Main Login'+' '+EDataBaseError(ExceptObject).Message);
  end;
  try
    if AstaServerSocket1.ThreadingModel = tmSingleSession then
      exit;
    for i:=0 to AstaServerSocket1.SessionList.Count - 1 do begin
      Adm := AstaServerSocket1.SessionList.GetSession(i) as TAstaOracleDataModule;
      Adm.MainSession.Close;
      Adm.MainSession.Open;
      LogIt('Session '+InttoStr(i)+' reconnected');
    end;
  except
    LogIt('Session List Reconnect Problem. '+EDataBaseError(ExceptObject).Message);
    //try again!!!
    AstaServerSocket1.SessionList.Free;
    AstaServerSocket1.SessionList:=nil;
    AstaServerSocket1.CreateSessionsForDbThreads(True);
  end;
end;

procedure TfrmMain.AstaServerSocket1ClientDBLogin(Sender: TObject;
  TheUserName, ThePassword, TheAppName: String; var Verified: Boolean;
  var ADataBase: TComponent);
begin
  try
    ADatabase := TAstaOracleDataModule.Create(nil);
    with ADataBase as TAstaOracleDataModule do begin
      MainSession.UserName := TheUserName;
      MainSession.PassWord := ThePassword;
      MainSession.ServerName := dm.MainSession.ServerName;
      MainSession.SilentMode := True;
      MainSession.Open;
      Verified:=True;
    end;
  except
    logException(Sender as TCustomWinSocket,'Unable to LogIn: ' + EDataBaseError(ExceptObject).Message, True);
  end;
end;

procedure TfrmMain.AstaServerSocket1ThreadedDBSupplyQuery(Sender: TObject;
  ClientSocket: TCustomWinSocket; DBAction: TThreadDbAction;
  DataBaseStr: String; CreateNew: Boolean; var AQuery: TComponent;
  SQLOptions: TAstaSelectSQLOptionSet);
begin
  if Sender is TAstaThread then
    with Sender As TastaThread do begin
      if soPackets IN SQLOptions then
        case DBAction of
          ttstoredproc:
            begin
              AQuery := TOCIStoredProc.Create(nil);
              TOCIStoredProc(AQuery).DatabaseName :=
                TAstaOracleDataModule(TAstaThread(Sender).Session).MainSession.DataBaseName;
            end;
          else
            begin
              AQuery := TOCIQuery.Create(nil);
              TOCIQuery(AQuery).DatabaseName :=
                TAstaOracleDataModule(TAstaThread(Sender).Session).MainSession.DataBaseName;
            end;
        end
      else
        case dbaction of
          tttransaction, tttransactionstart:
            AQuery := TAstaOracleDataModule(Session).MainSession;
          ttexec:
            AQuery := TAstaOracleDataModule(Session).ExecQuery;
          else
            AQuery := TAstaOracleDataModule(Session).SelectQuery;
        end;
    end
  else
    case DBAction of
      ttstoredproc:
        AQuery := DM.SelectQuery;
      ttexec:
        AQuery := DM.ExecQuery;
      tttransaction, tttransactionstart:
        AQuery := DM.MainSession;
      else
        AQuery := DM.SelectQuery;
    end;
end;

procedure TfrmMain.AstaServerSocket1StoredProcedure(Sender: TObject;
  ClientSocket: TCustomWinSocket; AQuery: TComponent; DataBaseStr,
  AStoredProcName: String; ClientParams: TAstaParamList;
  NoResultSet: Boolean);
var
  I: Integer;
begin
  try
    LogIt('StoredProcedure: ' + AStoredProcName);
    TOCIStoredProc(AQuery).Close;
    if AstaServerSocket1.UseThreads = tmSingleSession then begin
      if (DataBaseStr <> '') then
        DM.ExecProc.DataBaseName := DataBaseStr
      else if (DM.ExecProc.DataBaseName = '') or
              (DM.ExecProc.DataBaseName <> AstaDataBase) then
        DM.ExecProc.DataBaseName := AstaDataBase;
    end;
    TOCIStoredProc(AQuery).StoredProcName := AStoredProcName;
    TOCIStoredProc(AQuery).Prepare;
    if (ClientParams.Count = 0) and (TOCIStoredProc(AQuery).paramCount > 0) then
      raise EDataBAseError.create('No Client Params received for ' + AStoredProcName);
    for i := 0 to Clientparams.Count - 1 do
      TOCIStoredProc(AQuery).ParambyName(ClientParams[i].Name).Value := ClientParams[i].Value;
    TOCIStoredProc(Aquery).ExecProc;
    LogIt(AStoredProcName + ' executed. ');
    ClientParams.Clear;
    for i := 0 to TOCIStoredProc(AQuery).Params.Count - 1 do
      with TOCIStoredProc(AQuery).Params[i] do
        if ParamType in [db.ptOutPut, db.ptInputOutput, db.ptResult] then begin
          if ClientParams.FindParam(Name) = nil then
            ClientParams.CreateParam(DataType, Name, TAstaParamType(ord(ParamType)));
          ClientParams.ParamByName(Name).Value := Value;
        end;
  except
    LogException(ClientSocket, Exception(exceptObject).Message, True);
  end;
end;

procedure TfrmMain.AstaServerSocket1CodedMessage(Sender: TObject;
  ClientSocket: TCustomWinSocket; MsgID: Integer; Msg: String);
begin
  Case Msgid of
  1000: ReLogonToAllSessions;
  end;
end;

procedure TfrmMain.AstaServerSocket1InsertAutoIncrementFetch(
  Sender: TObject; ClientSocket: TCustomWinSocket; AQuery: TComponent;
  TheDatabase, TheTable, TheAutoIncField: String;
  var AutoIncrementValue: Integer);
begin
  with AQuery as TOCIQuery do begin
    sql.clear;
    sql.add('select aol_release_headers_s1.CurrVal release_id');
    Close;
    Open;
    if not eof then
      AutoIncrementValue := Fields[0].AsInteger;
  end;
end;

initialization

  FOCIDatabaseNameExpandMode := deUseThread;

end.


