{***************************************************}
{File:      NCNamOpt.PAS                            }
{Revision:  1.02 / 06.02.2000                       }
{Comment:   Component naming expert options dialog  }
{Copyright: (c) 1997-2000, Dmitry Arefiev           }
{Author:    Dmitry Arefiev, dmitrya@inthink.com     }
{***************************************************}
{$I NCOciDef.inc}

unit NCNamOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, NCCmpNmr, NCNamExp, Menus, ComCtrls;

type
  TNameExpFrm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PopupMenu1: TPopupMenu;
    C1: TMenuItem;
    T1: TMenuItem;
    V1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    U1: TMenuItem;
    L1: TMenuItem;
    P1: TMenuItem;
    S1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    TabSheet3: TTabSheet;
    HotKey1: THotKey;
    Label2: TLabel;
    Label5: TLabel;
    HotKey2: THotKey;
    N4: TMenuItem;
    N5: TMenuItem;
    T2: TMenuItem;
    C2: TMenuItem;
    CheckBox6: TCheckBox;
    procedure MIClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FCompNamer: TNCCompNamer;
    FCompExpert: TNCComponentNamingExpert;
    procedure LoadData;
    procedure SaveData;
  public
    { Public declarations }
  end;

  procedure NCCompNamerEdt(ACompNamer: TNCCompNamer;
    ACompExpert: TNCComponentNamingExpert);

var
  NameExpFrm: TNameExpFrm;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

implementation

{$R *.DFM}

Uses NCUIUtil, NCStrs;

procedure TNameExpFrm.FormCreate(Sender: TObject);
begin
    IUStr2Font(SDefaultFont, Font);
    Label3.Font := Font;
    Label3.Font.Style := [fsBold];
end;

procedure TNameExpFrm.LoadData;
begin
    with FCompNamer do begin
        Edit1.Text := StripPrefixs;
        CheckBox1.Checked := nsRemoveUCa in Options;
        CheckBox2.Checked := nsRemoveLCa in Options;
        CheckBox3.Checked := nsRemoveUCb in Options;
        CheckBox4.Checked := nsRemoveLCb in Options;
        CheckBox6.Checked := nsRemoveOver in Options;
        CheckBox5.Checked := nsPrefixsNoCase in Options;
        Memo1.Lines := NameFormats;
        HotKey1.HotKey := FCompExpert.NamingHotKey;
        HotKey2.HotKey := FCompExpert.OptHotKey;
    end;
end;

procedure TNameExpFrm.SaveData;
begin
    with FCompNamer do begin
        StripPrefixs := Edit1.Text;
        Options := [];
        if CheckBox1.Checked then
            Options := Options + [nsRemoveUCa];
        if CheckBox2.Checked then
            Options := Options + [nsRemoveLCa];
        if CheckBox3.Checked then
            Options := Options + [nsRemoveUCb];
        if CheckBox4.Checked then
            Options := Options + [nsRemoveLCb];
        if CheckBox6.Checked then
            Options := Options + [nsRemoveOver];
        if CheckBox5.Checked then
            Options := Options + [nsPrefixsNoCase];
        NameFormats := Memo1.Lines;
        FCompExpert.NamingHotKey := HotKey1.HotKey;
        FCompExpert.OptHotKey := HotKey2.HotKey;
    end;
end;

procedure TNameExpFrm.MIClick(Sender: TObject);
var
    s: String;
    i: Integer;
begin
    s := TMenuItem(Sender).Hint;
    for i := 1 to Length(s) do
        SendChar(Memo1, s[i]);
end;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

procedure NCCompNamerEdt(ACompNamer: TNCCompNamer; ACompExpert: TNCComponentNamingExpert);
begin
    if NameExpFrm = nil then
        Application.CreateForm(TNameExpFrm, NameExpFrm);
    with NameExpFrm do
    try
        FCompNamer := ACompNamer;
        FCompExpert := ACompExpert;
        LoadData;
        if ShowModal = mrOK then
            SaveData;
    finally
        Free;
        NameExpFrm := nil;
    end;
end;

end.
