{***********************************************}
{File:      NCQBFClc.PAS                        }
{Revision:  2.03 / 22.06.98                     }
{Comment:   QBF calculation dialog              }
{Copyright: (c) 1997, Nica-Com Ltd.             }
{E-Mail:    diman@ncom.nnov.su                  }
{***********************************************}

unit NCQBFClc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ncselfld, StdCtrls, Buttons, ExtCtrls, NCQBF, DB;

type
  TNCQBFCalculateDlg = class(TNCSelFldDlg)
    Label2: TLabel;
    SelOperCB: TComboBox;
    DistinctCHB: TCheckBox;
    HelpBtn: TBitBtn;
    CancelBtn: TBitBtn;
    OKBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure SelFldCBChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function GetOperation: TQBFCalcOperations;
    procedure SetLockDistinct(AValue: Boolean);
  public
    { Public declarations }
    property DataSource;
    property Field;
    property Operation: TQBFCalcOperations read GetOperation;
    property LockDistinct: Boolean write SetLockDistinct;
  end;

var
  NCQBFCalculateDlg: TNCQBFCalculateDlg;

implementation

{$R *.DFM}

procedure TNCQBFCalculateDlg.FormCreate(Sender: TObject);
begin
    inherited;
    IncludeFields := [ifCalculated];
//  SelOperCB.ItemIndex := 0;
end;

function TNCQBFCalculateDlg.GetOperation: TQBFCalcOperations;
begin
    Result := [];
    if SelOperCB.ItemIndex <> -1 then
        Include(Result, TQBFCalcOperation(SelOperCB.ItemIndex));
    if DistinctCHB.Checked then
        Include(Result, coDISTINCT);
end;

procedure TNCQBFCalculateDlg.SelFldCBChange(Sender: TObject);
begin
    if Field <> nil then
        if (Field.DataType in [ftSmallint, ftInteger, ftWord, ftFloat,
           ftCurrency, ftBCD]) then
            SelOperCB.ItemIndex := 0
        else
            SelOperCB.ItemIndex := 1;
end;

procedure TNCQBFCalculateDlg.FormShow(Sender: TObject);
begin
    inherited;
    SelOperCB.SetFocus;
end;

procedure TNCQBFCalculateDlg.SetLockDistinct(AValue: Boolean);
begin
    DistinctCHB.Enabled := not AValue;
    DistinctCHB.Checked := AValue;
end;

end.
