{***********************************************}
{File:      NCQBFLoc.PAS                        }
{Revision:  2.03 / 15.10.98                     }
{Comment:   QBF DB search dialog                }
{Copyright: (c) 1997-1998, Nica-Com Ltd.        }
{E-Mail:    diman@ncom.nnov.su                  }
{***********************************************}

unit NCQBFLoc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  NCSelFld, StdCtrls, Buttons, ExtCtrls, NCQBF, Menus;

type
  TNCQBFLocateDlg = class(TNCSelFldDlg)
    Label2: TLabel;
    MaskEdt: TEdit;
    LocFirstBtn: TBitBtn;
    LocPrevBtn: TBitBtn;
    LocNextBtn: TBitBtn;
    LocLastBtn: TBitBtn;     
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    procedure MaskEdtChange(Sender: TObject);
    procedure LocFirstBtnClick(Sender: TObject);
    procedure LocPrevBtnClick(Sender: TObject);
    procedure LocNextBtnClick(Sender: TObject);
    procedure LocLastBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SetBtnEnabled;
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    { Private declarations }
    FQBF: TNCQBF;
  public
    { Public declarations }
    property QBF: TNCQBF read FQBF write FQBF;
  end;

var
  NCQBFLocateDlg: TNCQBFLocateDlg;

{ ---------------------------------------------------------------- }
{ ---------------------------------------------------------------- }

implementation

{$R *.DFM}


Uses NCDBUtil, DB;

procedure TNCQBFLocateDlg.MaskEdtChange(Sender: TObject);
begin
    FQBF.OperationField := Field;
    FQBF.LocateMask := MaskEdt.Text;
    SetBtnEnabled;
end;

procedure TNCQBFLocateDlg.SetBtnEnabled;
var
    enableAll: Boolean;
begin
    enableAll := FQBF.CanNextLocate and (MaskEdt.Text <> '') and
        (SelFldCB.ItemIndex <> -1);
    if {not LocFirstBtn.Enabled and} enableAll then begin
        LocFirstBtn.Default := True;
        LocNextBtn.Default := False;
    end;
    LocFirstBtn.Enabled := enableAll;
    LocPrevBtn.Enabled := enableAll;
    LocNextBtn.Enabled := enableAll;
    LocLastBtn.Enabled := enableAll;
end;

procedure TNCQBFLocateDlg.LocFirstBtnClick(Sender: TObject);
begin
    FQBF.DoLocate(True, 1);
    LocFirstBtn.Default := False;
    LocNextBtn.Default := True;
end;

procedure TNCQBFLocateDlg.LocPrevBtnClick(Sender: TObject);
begin
    FQBF.DoLocate(False, -1);
end;

procedure TNCQBFLocateDlg.LocNextBtnClick(Sender: TObject);
begin
    FQBF.DoLocate(False, 1);
end;

procedure TNCQBFLocateDlg.LocLastBtnClick(Sender: TObject);
begin
    FQBF.DoLocate(True, -1);
end;

procedure TNCQBFLocateDlg.CancelBtnClick(Sender: TObject);
begin
    Hide;
end;

procedure TNCQBFLocateDlg.FormCreate(Sender: TObject);
begin
    inherited;
    DULoadNavBtnGlyph(LocFirstBtn, LocPrevBtn, LocNextBtn, LocLastBtn);
    IncludeFields := [ifCalculated, ifBLOB];
end;

procedure TNCQBFLocateDlg.FormShow(Sender: TObject);
begin
    DataSource := FQBF.DataSource;
    Field := FQBF.OperationField;
    MaskEdt.Text := FQBF.LocateMask;
    ShowHint := FQBF.ShowHint;
    SetBtnEnabled;
    inherited;
    MaskEdt.SetFocus;
end;

procedure TNCQBFLocateDlg.N2Click(Sender: TObject);
begin
    CancelBtnClick(nil);
end;

procedure TNCQBFLocateDlg.N1Click(Sender: TObject);
begin
    Hide;
    if FormStyle = fsStayOnTop then
        FormStyle := fsNormal
    else
        FormStyle := fsStayOnTop;
    Show;
end;

procedure TNCQBFLocateDlg.PopupMenu1Popup(Sender: TObject);
begin
    N1.Checked := FormStyle = fsStayOnTop;
end;

end.
